#include "HT46F47E.h"

//Traffic Light
//Body: HT48C10-1
//Mask option
//All the mask options use the default value.

const unsigned char table[16]={
0x14, 0x4, 0x14, 0x4, 0x14, 0x4, 0x14, 0x24,
0x41, 0x40, 0x41, 0x40,0x41, 0x40, 0x41, 0x42 };

#pragma vector isr_4 @ 0x4
#pragma vector isr_8 @ 0x8
#pragma vector isr_c @ 0xc

//ISR for safequard
void isr_4(){} // external ISR
void isr_8(){} // timer/event 0
void isr_c(){} // timer/event 1

//initialize registers for safeguard
void safeguard_init(){
	_intc = 0;
	_tmrc = 0;
	_tmr = 0;
	_pac = 0xff; //input mode
	_pbc = 0xff;

}

//a long time delay
void mydelay(unsigned int times){
	while(times--)	_delay(65000);
}

void main(){
	unsigned char i, j, idx;

	safeguard_init();

	_pac = 0; //set port A to output port
	_pa = 0; //zero port A (all light on)
	while(1) {
		idx = 0;
		for(i=0; i!=2; i++) {
			_pa = table[idx];
			idx++;
			mydelay(8);
			for(j=0; j!=6; j++) {
				_pa = table[idx];
				idx++;
				mydelay(1);
			}
			_pa = table[idx];
			idx++;
			mydelay(4);
		}
	}
}
